'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _immutableCursorsLibKeyedCursor = require('immutable-cursors/lib/KeyedCursor');

var _immutableCursorsLibKeyedCursor2 = _interopRequireDefault(_immutableCursorsLibKeyedCursor);

var _immutable = require('immutable');

var TreeCursor = (function (_KeyedCursor) {
	_inherits(TreeCursor, _KeyedCursor);

	function TreeCursor() {
		_classCallCheck(this, TreeCursor);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		_get(Object.getPrototypeOf(TreeCursor.prototype), 'constructor', this).apply(this, args);
		this._rootPath = this._sharedOptions.rootPath;
		this._treeUtils = this._api.treeUtils;
	}

	_createClass(TreeCursor, [{
		key: '_callOnRoot',
		value: function _callOnRoot(fn) {
			for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
				args[_key2 - 1] = arguments[_key2];
			}

			var result = fn.call.apply(fn, [this._treeUtils, this._rootData, this._rootPath].concat(args));
			if (_immutable.Seq.isSeq(result) || Array.isArray(result)) {
				return this._api.makeTreeCursor(this, result);
			}
			return result;
		}
	}, {
		key: '_callOnThis',
		value: function _callOnThis(fn) {
			for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
				args[_key3 - 1] = arguments[_key3];
			}

			var result = fn.call.apply(fn, [this._treeUtils, this._rootData, this._keyPath].concat(args));
			if (_immutable.Seq.isSeq(result) || Array.isArray(result)) {
				return this._api.makeTreeCursor(this, result);
			}
			return result;
		}
	}, {
		key: 'id',
		value: function id() {
			return this._callOnThis(this._treeUtils.id);
		}
	}, {
		key: 'type',
		value: function type() {
			return this._callOnThis(this._treeUtils.type);
		}
	}, {
		key: 'root',
		value: function root() {
			return this._api.makeTreeCursor(this, this._rootPath);
		}
	}, {
		key: 'findInTree',
		value: function findInTree(comparator) {
			return this._callOnThis(this._treeUtils.findInTree, comparator);
		}
	}, {
		key: 'filterInTree',
		value: function filterInTree(comparator) {
			return this._callOnThis(this._treeUtils.filterInTree, comparator);
		}
	}, {
		key: 'getById',
		value: function getById(id) {
			return this._callOnThis(this._treeUtils.getById, id);
		}
	}, {
		key: 'getByType',
		value: function getByType() {
			for (var _len4 = arguments.length, types = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
				types[_key4] = arguments[_key4];
			}

			return this._callOnThis.apply(this, [this._treeUtils.getByType].concat(types));
		}
	}, {
		key: 'firstChild',
		value: function firstChild() {
			return this._callOnRoot(this._treeUtils.firstChild, this._keyPath);
		}
	}, {
		key: 'lastChild',
		value: function lastChild() {
			return this._callOnRoot(this._treeUtils.lastChild, this._keyPath);
		}
	}, {
		key: 'siblings',
		value: function siblings() {
			return this._callOnRoot(this._treeUtils.siblings, this._keyPath);
		}
	}, {
		key: 'previousSibling',
		value: function previousSibling() {
			return this._callOnRoot(this._treeUtils.previousSibling, this._keyPath);
		}
	}, {
		key: 'nextSibling',
		value: function nextSibling() {
			return this._callOnRoot(this._treeUtils.nextSibling, this._keyPath);
		}
	}, {
		key: 'parent',
		value: function parent() {
			return this._callOnRoot(this._treeUtils.parent, this._keyPath);
		}
	}, {
		key: 'ancestors',
		value: function ancestors() {
			return this._callOnRoot(this._treeUtils.ancestors, this._keyPath);
		}
	}, {
		key: 'descendants',
		value: function descendants() {
			return this._callOnRoot(this._treeUtils.descendants, this._keyPath);
		}
	}, {
		key: 'childIndex',
		value: function childIndex() {
			return this._callOnRoot(this._treeUtils.childIndex, this._keyPath);
		}
	}, {
		key: 'childNodes',
		value: function childNodes() {
			return this._callOnRoot(this._treeUtils.childNodes, this._keyPath);
		}
	}, {
		key: 'childAt',
		value: function childAt(index) {
			return this._callOnRoot(this._treeUtils.childAt, this._keyPath, index);
		}
	}, {
		key: 'numChildNodes',
		value: function numChildNodes() {
			return this._callOnRoot(this._treeUtils.numChildNodes, this._keyPath);
		}
	}, {
		key: 'hasChildNodes',
		value: function hasChildNodes() {
			return this._callOnRoot(this._treeUtils.hasChildNodes, this._keyPath);
		}
	}, {
		key: 'right',
		value: function right() {
			return this._callOnRoot(this._treeUtils.right, this._keyPath);
		}
	}, {
		key: 'left',
		value: function left() {
			return this._callOnRoot(this._treeUtils.left, this._keyPath);
		}
	}, {
		key: 'firstDescendant',
		value: function firstDescendant() {
			return this._callOnRoot(this._treeUtils.firstDescendant, this._keyPath);
		}
	}, {
		key: 'lastDescendant',
		value: function lastDescendant() {
			return this._callOnRoot(this._treeUtils.lastDescendant, this._keyPath);
		}
	}]);

	return TreeCursor;
})(_immutableCursorsLibKeyedCursor2['default']);

exports['default'] = TreeCursor;
module.exports = exports['default'];