'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _immutable = require('immutable');

var TreeUtils = (function () {
	function TreeUtils() {
		var idKey = arguments.length <= 0 || arguments[0] === undefined ? 'id' : arguments[0];
		var typeKey = arguments.length <= 1 || arguments[1] === undefined ? 'type' : arguments[1];
		var childNodesKey = arguments.length <= 2 || arguments[2] === undefined ? 'childNodes' : arguments[2];

		_classCallCheck(this, TreeUtils);

		this._idKey = idKey;
		this._childNodesKey = childNodesKey;
	}

	_createClass(TreeUtils, [{
		key: 'id',
		value: function id(state, keyPath) {
			return state.getIn(keyPath.concat(this._idKey));
		}
	}, {
		key: '__iterate',
		value: regeneratorRuntime.mark(function __iterate(state, rootPath) {
			var stack, keyPath, item, childNodes, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, i;

			return regeneratorRuntime.wrap(function __iterate$(context$2$0) {
				while (1) switch (context$2$0.prev = context$2$0.next) {
					case 0:
						stack = [rootPath];

					case 1:
						if (!(stack.length > 0)) {
							context$2$0.next = 28;
							break;
						}

						keyPath = stack.shift();
						context$2$0.next = 5;
						return keyPath;

					case 5:
						item = state.getIn(keyPath), childNodes = item.get(this._childNodesKey);

						if (!(childNodes && childNodes.size > 0)) {
							context$2$0.next = 26;
							break;
						}

						_iteratorNormalCompletion = true;
						_didIteratorError = false;
						_iteratorError = undefined;
						context$2$0.prev = 10;

						for (_iterator = item.get(this._childNodesKey).keys()[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
							i = _step.value;

							stack.push(keyPath.concat(this._childNodesKey, i));
						}
						context$2$0.next = 18;
						break;

					case 14:
						context$2$0.prev = 14;
						context$2$0.t0 = context$2$0['catch'](10);
						_didIteratorError = true;
						_iteratorError = context$2$0.t0;

					case 18:
						context$2$0.prev = 18;
						context$2$0.prev = 19;

						if (!_iteratorNormalCompletion && _iterator['return']) {
							_iterator['return']();
						}

					case 21:
						context$2$0.prev = 21;

						if (!_didIteratorError) {
							context$2$0.next = 24;
							break;
						}

						throw _iteratorError;

					case 24:
						return context$2$0.finish(21);

					case 25:
						return context$2$0.finish(18);

					case 26:
						context$2$0.next = 1;
						break;

					case 28:
					case 'end':
						return context$2$0.stop();
				}
			}, __iterate, this, [[10, 14, 18, 26], [19,, 21, 25]]);
		})
	}, {
		key: 'findInTree',
		value: function findInTree(state, rootPath, comparator) {
			var _iteratorNormalCompletion2 = true;
			var _didIteratorError2 = false;
			var _iteratorError2 = undefined;

			try {
				for (var _iterator2 = this.__iterate(state, rootPath)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
					var keyPath = _step2.value;

					if (comparator(state.getIn(keyPath)) === true) {
						return keyPath;
					}
				}
			} catch (err) {
				_didIteratorError2 = true;
				_iteratorError2 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion2 && _iterator2['return']) {
						_iterator2['return']();
					}
				} finally {
					if (_didIteratorError2) {
						throw _iteratorError2;
					}
				}
			}
		}
	}, {
		key: 'filterInTree',
		value: function filterInTree(state, rootPath, comparator) {
			var result = [];
			var _iteratorNormalCompletion3 = true;
			var _didIteratorError3 = false;
			var _iteratorError3 = undefined;

			try {
				for (var _iterator3 = this.__iterate(state, rootPath)[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
					var keyPath = _step3.value;

					if (comparator(state.getIn(keyPath)) === true) {
						result.push(keyPath);
					}
				}
			} catch (err) {
				_didIteratorError3 = true;
				_iteratorError3 = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion3 && _iterator3['return']) {
						_iterator3['return']();
					}
				} finally {
					if (_didIteratorError3) {
						throw _iteratorError3;
					}
				}
			}

			return result;
		}
	}, {
		key: 'getById',
		value: function getById(state, rootPath, id) {
			var _this = this;

			return this.findInTree(state, rootPath, function (item) {
				return item.get(_this._idKey) === id;
			});
		}
	}, {
		key: 'getByArbitrary',
		value: function getByArbitrary(state, rootPath, idOrKeyPath) {
			return _immutable.Seq.isSeq(idOrKeyPath) ? idOrKeyPath : this.getById(state, rootPath, idOrKeyPath);
		}
	}, {
		key: 'nextSibling',
		value: function nextSibling(state, rootPath, id) {
			var keyPath = this.getByArbitrary(state, rootPath, id),
			    index = Number(keyPath.last()),
			    nextSiblingPath = keyPath.skipLast(1).concat(index + 1);
			return state.hasIn(nextSiblingPath) ? nextSiblingPath : undefined;
		}
	}, {
		key: 'previousSibling',
		value: function previousSibling(state, rootPath, id) {
			var keyPath = this.getByArbitrary(state, rootPath, id),
			    index = Number(keyPath.last());
			return index > 0 ? keyPath.skipLast(1).concat(index - 1) : undefined;
		}
	}, {
		key: 'firstChild',
		value: function firstChild(state, rootPath, id) {
			var keyPath = this.getByArbitrary(state, rootPath, id).concat([this._childNodesKey, 0]);
			return state.hasIn(keyPath) ? keyPath : undefined;
		}
	}, {
		key: 'lastChild',
		value: function lastChild(state, rootPath, id) {
			var keyPath = this.getByArbitrary(state, rootPath, id).concat([this._childNodesKey]),
			    item = state.getIn(keyPath);
			if (item && item.size > 0) {
				return keyPath.concat([item.size - 1]);
			}
		}
	}, {
		key: 'siblings',
		value: function siblings(state, rootPath, id) {
			var keyPath = this.getByArbitrary(state, rootPath, id),
			    index = Number(keyPath.last()),
			    parentChildren = keyPath.skipLast(1),
			    item = state.getIn(parentChildren);
			if (item) {
				var result = [];
				var _iteratorNormalCompletion4 = true;
				var _didIteratorError4 = false;
				var _iteratorError4 = undefined;

				try {
					for (var _iterator4 = item.keys()[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
						var i = _step4.value;

						if (i !== index) {
							result.push(parentChildren.concat(i));
						}
					}
				} catch (err) {
					_didIteratorError4 = true;
					_iteratorError4 = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion4 && _iterator4['return']) {
							_iterator4['return']();
						}
					} finally {
						if (_didIteratorError4) {
							throw _iteratorError4;
						}
					}
				}

				return result;
			}
		}
	}, {
		key: 'childNodes',
		value: function childNodes(state, rootPath, id) {
			var keyPath = this.getByArbitrary(state, rootPath, id).concat(this._childNodesKey),
			    item = state.getIn(keyPath);
			if (item) {
				var l = item.size,
				    result = [];
				for (var i = 0; i < l; i++) {
					result.push(keyPath.concat(i));
				}
				return result;
			}
		}
	}, {
		key: 'childAt',
		value: function childAt(state, rootPath, id, index) {
			var keyPath = this.getByArbitrary(state, rootPath, id).concat(this._childNodesKey, index);
			return state.hasIn(keyPath) ? keyPath : undefined;
		}
	}, {
		key: 'descendants',
		value: function descendants(state, rootPath, id) {
			var _this2 = this;

			var keyPath = this.getByArbitrary(state, rootPath, id);
			return this.filterInTree(state, keyPath, function (item) {
				return item.get(_this2._idKey) !== _this2.id(state, keyPath);
			});
		}
	}, {
		key: 'childIndex',
		value: function childIndex(state, rootPath, id) {
			return Number(this.getByArbitrary(state, rootPath, id).last());
		}
	}, {
		key: 'hasChildNodes',
		value: function hasChildNodes(state, rootPath, id) {
			var keyPath = this.getByArbitrary(state, rootPath, id).concat(this._childNodesKey),
			    item = state.getIn(keyPath);
			return typeof item !== 'undefined' && item.size > 0;
		}
	}, {
		key: 'numChildNodes',
		value: function numChildNodes(state, rootPath, id) {
			var keyPath = this.getByArbitrary(state, rootPath, id).concat(this._childNodesKey),
			    item = state.getIn(keyPath);
			return typeof item !== 'undefined' ? item.size : 0;
		}
	}, {
		key: 'parent',
		value: function parent(state, rootPath, id) {
			var keyPath = this.getByArbitrary(state, rootPath, id);
			return keyPath && keyPath.size ? keyPath.slice(0, -2) : undefined;
		}
	}, {
		key: 'ancestors',
		value: function ancestors(state, rootPath, id) {
			return this.getByArbitrary(state, rootPath, id).reduceRight(function (memo, value, index, keyPath) {
				if ((index - rootPath.size) % 2 === 0 && index >= rootPath.size) {
					memo.push(new _immutable.Seq(keyPath.takeLast(index).reverse().toArray()));
				}
				return memo;
			}, []);
		}
	}, {
		key: 'right',
		value: function right(state, rootPath, id) {
			var l = rootPath.size,
			    keyPath = this.getByArbitrary(state, rootPath, id),
			    firstChild = this.firstChild(state, rootPath, keyPath);

			if (firstChild) {
				return firstChild;
			}

			var nextSibling = this.nextSibling(state, rootPath, keyPath);
			if (nextSibling) {
				return nextSibling;
			}

			var parent = this.parent(state, rootPath, keyPath),
			    nextSiblingOfParent = undefined;

			while (parent && parent.size >= l) {
				nextSiblingOfParent = this.nextSibling(state, rootPath, parent);
				if (nextSiblingOfParent) {
					return nextSiblingOfParent;
				}
				parent = this.parent(state, rootPath, parent);
			}
		}
	}, {
		key: 'left',
		value: function left(state, rootPath, id) {
			var keyPath = this.getByArbitrary(state, rootPath, id),
			    lastChild = this.previousSibling(state, rootPath, keyPath);

			while (lastChild) {
				if (!this.hasChildNodes(state, rootPath, lastChild)) {
					return lastChild;
				}
				lastChild = this.lastChild(state, rootPath, lastChild);
			}

			var parent = this.parent(state, rootPath, keyPath);
			if (parent && parent.size >= rootPath.size) {
				return parent;
			}
		}
	}, {
		key: 'firstDescendant',
		value: function firstDescendant(state, rootPath, id) {
			return this.firstChild(state, rootPath, id);
		}
	}, {
		key: 'lastDescendant',
		value: function lastDescendant(state, rootPath, id) {
			var keyPath = this.lastChild(state, rootPath, id);
			while (keyPath && this.hasChildNodes(state, rootPath, keyPath)) {
				keyPath = this.lastChild(state, rootPath, keyPath);
			}
			return keyPath;
		}
	}]);

	return TreeUtils;
})();

exports['default'] = TreeUtils;
module.exports = exports['default'];