import Immutable from 'immutable';
import Cursor from '../src/';
import pathToSeq from 'immutable-cursors/lib/pathToSeq';

function immutableEqual(a, b) {
    return a instanceof Immutable.Iterable && b instanceof Immutable.Iterable ?
        Immutable.is(a, b) :
        jasmine.undefined;
}

function mock(name) {
	return jasmine.createSpyObj(name, ['exec']).exec;
}

describe('Cursor', () => {

	let json = {
		items: [
			{
				name: 'Luke Skywalker'
			},
			{
				name: 'Leia Organa'
			},
			{
				name: 'Han Solo'
			}
		]
	};

	it('supports whole Seq API', () => {
		let data = Immutable.fromJS(json);
        let cursor = Cursor.from(data, ['items']);

		let smallCursor = cursor.take(1);
		expect(smallCursor.size).toEqual(1);
		expect(smallCursor.toJS()).toEqual([
			{
				name: 'Luke Skywalker'
			}
		]);
		expect(smallCursor.isSubset(cursor)).toBeTruthy();
	});
});
